<?php
namespace Bushelpowered\Api\Platform\Eventstore\Request;
        
class GetEventsRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    public string $stream;
    /** @var null|string $startingFrom of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $startingFrom = null;
    public ?\Bushelpowered\Api\Platform\Eventstore\Common\CompactedBy $compactedBy = null;
    public ?\Bushelpowered\Api\Platform\Eventstore\Common\EventFilter $filter = null;
    public ?\Bushelpowered\Api\Platform\Eventstore\Common\EventPagination $pagination = null;

    /**
     * @param  null|string  $startingFrom of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $stream, ?string $startingFrom, ?\Bushelpowered\Api\Platform\Eventstore\Common\CompactedBy $compactedBy, ?\Bushelpowered\Api\Platform\Eventstore\Common\EventFilter $filter, ?\Bushelpowered\Api\Platform\Eventstore\Common\EventPagination $pagination)
    {
        $this->stream = $stream;
        $this->startingFrom = $startingFrom;
        $this->compactedBy = $compactedBy;
        $this->filter = $filter;
        $this->pagination = $pagination;
    }
    
    public function getPagination(): ?\Bushelpowered\Api\Platform\Eventstore\Common\EventPagination
    {
        return $this->pagination;
    }
}